// Craig S. Kaplan

// Using the table of hair and eye colours, create
// a silly visualization of the entire class from which
// the data was taken.  Draw little fake heads showing
// hair and eye colour; use the shape of the head for
// male/female.

void setup()
{
  size( 755, 705 );

  background( 255 );

  Face[] all = {};

  Table tab = loadTable( "haireyecolour.csv", "header" );
  
  for ( int idx = 0; idx < tab.getRowCount(); ++idx ) {
    int num = tab.getInt( idx, "Freq" );

    // Add one head for each person which these characteristics.
    for ( int jdx = 0; jdx < num; ++jdx ) {
      all = (Face[])append( all, new Face(
        tab.getString( idx, "Eye" ), 
        tab.getString( idx, "Hair" ), 
        tab.getString( idx, "Sex" ) ) );
    }
  }

  // Shuffle up the heads.
  for ( int idx = 0; idx < 100000; ++idx ) {
    int a = int( random( all.length ) );
    int b = int( random( all.length ) );
    Face tmp = all[a];
    all[a] = all[b];
    all[b] = tmp;
  }

  // Draw a grid.
  for ( int idx = 0; idx < all.length; ++idx ) {
    int y = idx / 30;
    int x = idx % 30;

    pushMatrix();
    translate( 5 + x * 25, 5 + y * 35 );
    all[idx].draw();
    popMatrix();
  }
}